unit MainForm;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, Menus,
  ExtCtrls, StdCtrls, ComCtrls, GL, GLU, GLExt, OpenGLContext, setupform,
  logoform, editform, addrecform, recviewform, types, procs, LazUTF8, wdb_io,
  wdb_vars, LCLIntf;

const
  TRACK_SURFACE_COUNT = 8;

type

  { TMForm }

  TMForm = class(TForm)
    Aimg: TImage;
    rm_view: TMenuItem;
    rm_edit: TMenuItem;
    rm_del: TMenuItem;
    RecMenu: TPopupMenu;
    tm_rhint: TMenuItem;
    tm_epop: TMenuItem;
    tm_del: TMenuItem;
    tm_colored: TMenuItem;
    tm_epush: TMenuItem;
    tm_rename: TMenuItem;
    tm_color: TMenuItem;
    TrackMenu: TPopupMenu;
    wlm1: TMenuItem;
    wlm2: TMenuItem;
    wlm3: TMenuItem;
    wlm4: TMenuItem;
    wlm5: TMenuItem;
    wlm6: TMenuItem;
    wlm7: TMenuItem;
    wlm8: TMenuItem;
    mf_reload: TMenuItem;
    mf_saveas: TMenuItem;
    mf_new: TMenuItem;
    OpenDialog1: TOpenDialog;
    PanelTop1: TStaticText;
    WLMenu: TPopupMenu;
    SaveDialog1: TSaveDialog;
    TBImages: TImageList;
    PanelTop: TStaticText;
    PanelBottom: TStaticText;
    TImg: TImage;
    MainMenu1: TMainMenu;
    medit: TMenuItem;
    me_setup: TMenuItem;
    mh_about: TMenuItem;
    mh_help: TMenuItem;
    mhelp: TMenuItem;
    me_editor: TMenuItem;
    mf_exit: TMenuItem;
    mf_save: TMenuItem;
    mf_open: TMenuItem;
    mfile: TMenuItem;
    MToolBar: TToolBar;
    tb_new: TToolButton;
    tb_open: TToolButton;
    tb_reload: TToolButton;
    tb_save: TToolButton;
    tb_saveas: TToolButton;
    tb_addrec: TToolButton;
    ToolButton2: TToolButton;
    tb_edit: TToolButton;
    tb_setup: TToolButton;
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormDropFiles(Sender: TObject; const FileNames: array of String);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormMouseWheel(Sender: TObject; Shift: TShiftState;
      WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
    procedure FormResize(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure me_editorClick(Sender: TObject);
    procedure me_setupClick(Sender: TObject);
    procedure mf_newClick(Sender: TObject);
    procedure mf_openClick(Sender: TObject);
    procedure mf_reloadClick(Sender: TObject);
    procedure mf_saveasClick(Sender: TObject);
    procedure mf_saveClick(Sender: TObject);
    procedure mh_aboutClick(Sender: TObject);
    procedure mh_helpClick(Sender: TObject);
    procedure OGLPaint(Sender: TObject);
    procedure OGLMouseDown(Sender: TObject; Button: TMouseButton; State: TShiftState; X, Y: LongInt);
    procedure OGLMouseUp(Sender: TObject; Button: TMouseButton; State: TShiftState; X, Y: LongInt);
    procedure OGLMouseMove(Sender: TObject; State: TShiftState; X, Y: LongInt);
    procedure OGLResize(Sender: TObject);
    procedure mf_exitClick(Sender: TObject);
    procedure PanelTop1Click(Sender: TObject);
    procedure rm_delClick(Sender: TObject);
    procedure rm_editClick(Sender: TObject);
    procedure rm_viewClick(Sender: TObject);
    procedure SetWDbuf; //Создание модели дороги
    procedure SetRDbuf; //Создание текстур записей
    procedure PaintRecord(Logo, Track: integer; Z: GLDouble);
    procedure tb_addrecClick(Sender: TObject);
    procedure tb_editClick(Sender: TObject);
    procedure tb_newClick(Sender: TObject);
    procedure tb_openClick(Sender: TObject);
    procedure tb_reloadClick(Sender: TObject);
    procedure tb_saveasClick(Sender: TObject);
    procedure tb_saveClick(Sender: TObject);
    procedure tb_setupClick(Sender: TObject);
    procedure tm_colorClick(Sender: TObject);
    procedure tm_coloredClick(Sender: TObject);
    procedure tm_delClick(Sender: TObject);
    procedure tm_epopClick(Sender: TObject);
    procedure tm_epushClick(Sender: TObject);
    procedure tm_renameClick(Sender: TObject);
    procedure tm_rhintClick(Sender: TObject);
    procedure TrackMenuPopup(Sender: TObject);
    procedure WayMove;
    procedure WayPoint; //(wp_index, wp_track, wp_record)
    procedure MakeTextTexture(txt: String; Center: Boolean; W,H: integer; BG:TColor; var tmem: pbyte);
    procedure wlm1Click(Sender: TObject);
    procedure wlm2Click(Sender: TObject);
    procedure wlm3Click(Sender: TObject);
    procedure wlm4Click(Sender: TObject);
    procedure wlm5Click(Sender: TObject);
    procedure wlm6Click(Sender: TObject);
    procedure wlm7Click(Sender: TObject);
    procedure wlm8Click(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
    OGL: TOpenGLControl;
  end;

var
  MForm: TForm;

implementation

{$R *.lfm}

{ TMForm }

procedure TMForm.mf_exitClick(Sender: TObject);
begin
 MForm.Close;
end;

procedure TMForm.PanelTop1Click(Sender: TObject);
begin
 WLMenu.PopUp;
end;

procedure TMForm.rm_delClick(Sender: TObject);
var
 n:longint;
begin
 if (wp_record < 0) or (wp_record >= Rcount) then exit;
 if (MessageDlg('Удаление записи',
      'Вы действиельно хотите удалить запись "'+Records[wp_record].Name+
       '" ?', mtCustom, mbOkCancel, 0 ) = mrCancel) then exit;
 for n:=wp_record to (Rcount-2) do Records[n]:=Records[n+1];
 dec(Rcount);
 WayMove;
 OGLPaint(MForm);
end;

procedure TMForm.rm_editClick(Sender: TObject);
begin
 FEdit.Show;
 Crec := Records[wp_record];
 FEdit.RecList.ItemIndex:=wp_record;
 FEdit.RecText.SetFocus;
end;

procedure TMForm.rm_viewClick(Sender: TObject);
begin
 FRecView.ShowRecord(wp_record);
end;

procedure TMForm.MakeTextTexture(txt: String; Center: Boolean; W,H: integer; BG:TColor; var tmem: pbyte);
var
 n,x,y,sh: integer;
 b: byte;
begin
 TImg.Picture.Bitmap.Canvas.Clear;
 TImg.Picture.Bitmap.PixelFormat:=pf32bit;
 TImg.Picture.Bitmap.Width:=W;
 TImg.Picture.Bitmap.Height:=H;
 TImg.Picture.Bitmap.Canvas.Brush.Color:=BG;
 TImg.Picture.Bitmap.Canvas.FillRect(Rect(0,0,W,H));
 sh:=TImg.Picture.Bitmap.Canvas.TextHeight('0')+5;
 //FreeMem(tmem);
 GetMem(tmem,W*H*4);
 b:=0; //Разделение текста на строки в массив SplitA
 y:=0;
 n:=0;
 for x:=0 to length(txt)-1 do
  begin
   SplitA[255]:=copy(txt,x+1,1);
   if (SplitA[255] = ' ') or (SplitA[255] = '-') then n:=x+1;
   SplitA[b]:=copy(txt,y+1,x-y);
   if ( TImg.Picture.Bitmap.Canvas.TextWidth(SplitA[b]) > W-10 ) then
    begin
     if (n<=y) then
      begin
       SplitA[b]:=copy(txt,y+1,x-y+1);
       y:=x+1;
      end else
       begin
        SplitA[b]:=copy(txt,y+1,n-y);
        y:=n;
       end;
     inc(b);
     if (H div sh < b) then break;
    end;
  end;
 if (y < length(txt)) then
  begin
   SplitA[b]:=copy(txt,y+1,length(txt)-y);
   inc(b);
  end;
 //Вывод текста на Bitmap.Canvas
 if Center then y:=(-sh*b + H) div 2 + 1 else y:=2;
 for n:=0 to b-1 do
  begin
   if not Center then x:=3 else
    x:=(W-TImg.Picture.Bitmap.Canvas.TextWidth(SplitA[n])) div 2 + 2;
   TImg.Picture.Bitmap.Canvas.TextOut(x,y,SplitA[n]);
   y:=y+sh;
  end;
 Application.ProcessMessages;
 tmem:=TImg.Picture.Bitmap.RawImage.Data;
 {$IFDEF WINDOWS}
 //Расставляем цвета на свои места в Windows
 for x:=0 to (W*H-1) do
  begin
   b:=tmem[x*4];
   tmem[x*4]:=tmem[x*4+2];
   tmem[x*4+2]:=b;
  end;
 {$ENDIF}
end;

procedure TMForm.wlm1Click(Sender: TObject);
begin
 cfg_wl:=0;
 SetWLT;
 WayMove;
end;

procedure TMForm.wlm2Click(Sender: TObject);
begin
 cfg_wl:=1;
 SetWLT;
 WayMove;
end;

procedure TMForm.wlm3Click(Sender: TObject);
begin
 cfg_wl:=2;
 SetWLT;
 WayMove;
end;

procedure TMForm.wlm4Click(Sender: TObject);
begin
 cfg_wl:=3;
 SetWLT;
 WayMove;
end;

procedure TMForm.wlm5Click(Sender: TObject);
begin
 cfg_wl:=4;
 SetWLT;
 WayMove;
end;

procedure TMForm.wlm6Click(Sender: TObject);
begin
 cfg_wl:=5;
 SetWLT;
 WayMove;
end;

procedure TMForm.wlm7Click(Sender: TObject);
begin
 cfg_wl:=6;
 SetWLT;
 WayMove;
end;

procedure TMForm.wlm8Click(Sender: TObject);
begin
 cfg_wl:=7;
 SetWLT;
 WayMove;
end;

procedure TMForm.SetWDbuf;
var
 n,m,s:longint;
 y,z,iy: GLdouble;
 c: TColor;
begin
 SetupChanged:=false;
 Editing:=True;
 PanelBottom.Color:=RGBtoColor(clr_b11*2,clr_b12*2,clr_b13*2);
 PanelTop.Color:=RGBtoColor(clr_b21*2,clr_b22*2,clr_b23*2);
 PanelTop1.Color:=RGBtoColor(clr_b21*2,clr_b22*2,clr_b23*2);
 if (clr_b21+clr_b22+clr_b23 > 191) then
  PanelTop.Font.Color:=clBlack
   else PanelTop.Font.Color:=clWhite;
 if (clr_b11+clr_b12+clr_b13 > 191) then
  PanelBottom.Font.Color:=clBlack
   else PanelBottom.Font.Color:=clWhite;
 PanelTop1.Font.Color:=PanelTop.Font.Color;
 if (RCount>0) then
  VTime1:=Records[RCount-1].DTime + 0.5
   else VTime1:=Now + 0.5;
 WayMove;
 Tsize:=(TRACK_SURFACE_COUNT+1)*6;
 WDBS:=Tsize*Tcount;
 setlength(WDbuf,WDBS);
 LimVX:=0.8-Tcount*cfg_tw;
 ViewX:=(0.2 + LimVX) / 2;
 s:=0;
 for n:=0 to Tcount-1 do
  begin
   s:=Tsize*n;
   WDbuf[s].x:=n*cfg_tw; WDbuf[s].y:=0; WDbuf[s].z:=1;                  //НЛ
   WDbuf[s+1].x:=n*cfg_tw; WDbuf[s+1].y:=0+cfg_hh; WDbuf[s+1].z:=1;     //ВЛ
   WDbuf[s+2].x:=(n+1)*cfg_tw; WDbuf[s+2].y:=0+cfg_hh; WDbuf[s+2].z:=1; //ВП
   WDbuf[s+3].x:=(n+1)*cfg_tw; WDbuf[s+3].y:=0+cfg_hh; WDbuf[s+3].z:=1; //ВП
   WDbuf[s+4].x:=n*cfg_tw; WDbuf[s+4].y:=0; WDbuf[s+4].z:=1;            //НЛ
   WDbuf[s+5].x:=(n+1)*cfg_tw; WDbuf[s+5].y:=0; WDbuf[s+5].z:=1;        //НП
   for m:=0 to TRACK_SURFACE_COUNT-1 do
    begin
     s:=s+6;
     z:=sqr(m / (TRACK_SURFACE_COUNT-1))*5.2;
     y:=1+cfg_hh-cos(z/3);
     z:=z+1;
     WDbuf[s]:=WDbuf[s-5];
     WDbuf[s+1].x:=n*cfg_tw; WDbuf[s+1].y:=y; WDbuf[s+1].z:=z;
     WDbuf[s+2].x:=(n+1)*cfg_tw; WDbuf[s+2].y:=y; WDbuf[s+2].z:=z;
     WDbuf[s+3]:=WDbuf[s+2];
     WDbuf[s+4]:=WDbuf[s];
     WDbuf[s+5]:=WDbuf[s-4];
    end;
  end;
 //Подготовка буфера для рисования значка записи
 y:=0.7*cfg_tw;
 iy:=y*2;
 RDbuf[0].x:=-y/2; RDbuf[0].y:=0; RDbuf[0].z:=0;       //НЛ
 RDbuf[1].x:=-y/2; RDbuf[1].y:=iy; RDbuf[1].z:=0;      //ВЛ
 RDbuf[2].x:=y/2; RDbuf[2].y:=iy; RDbuf[2].z:=0;       //ВП
 RDbuf[3].x:=y/2; RDbuf[3].y:=iy; RDbuf[3].z:=0;       //ВП
 RDbuf[4].x:=-y/2; RDbuf[4].y:=0; RDbuf[4].z:=0;       //НЛ
 RDbuf[5].x:=y/2; RDbuf[5].y:=0; RDbuf[5].z:=0;        //НП
 //Подготовка текстур заголовков дороги
 glGenTextures(Tcount, @WTID[0]);
 FLogo.Label2.Caption:='Пожалуйста, подождите...';
 for n:=0 to Tcount-1 do
  begin
   FLogo.Label3.Caption:=
    'Подготовка текстур заголовков ( '+inttostr(n+1)+' / '+inttostr(Tcount)+' ) ...';
   Application.ProcessMessages;
   if (n mod 2 = 0) then
    c:=RGBtoColor(clr_h11*2,clr_h12*2,clr_h13*2) else
     c:=RGBtoColor(clr_h21*2,clr_h22*2,clr_h23*2);
   MakeTextTexture(Tracks[n].Name, True, 64, 128, c, WTData[n]);
   glBindTexture(GL_TEXTURE_2D, WTID[n]);
   glTexImage2D(GL_TEXTURE_2D, 0, 4, 64, 128, 0, GL_RGBA, GL_UNSIGNED_BYTE, WTData[n]);
   glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
   glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
   glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
   glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
  end;
 Editing:=False;
end;

procedure TMForm.SetRDbuf;
var
 n,x,ic: integer;
 b: byte;
 alp,t: ^byte;
begin
 //Подготовка текстур записей
 Editing:=True;
 ic:=FEdit.LogosImages.Count-1;
 setlength(TTID,ic);
 setlength(TTdata,ic);
 //Достаём маску альфы
 FEdit.LogosImages.GetBitmap(0,Aimg.Picture.Bitmap);
 GetMem(t,65536);
 GetMem(alp,16384);
 t:=Aimg.Picture.Bitmap.RawImage.Data;
 for n:=0 to 16383 do
  alp[n]:=255-t[n*4];
 FreeMem(t);
 //Создаём текстуры
 glGenTextures(ic, @TTID[0]);
 for n:=0 to (ic-1) do
  begin
   FLogo.Label3.Caption:=
    'Подготовка текстур значков ( '+inttostr(n+1)+' / '+inttostr(ic)+' ) ...';
   Application.ProcessMessages;
   FEdit.LogosImages.GetBitmap(n+1,Timg.Picture.Bitmap);
   GetMem(TTdata[n],65536);
   TTData[n]:=Timg.Picture.Bitmap.RawImage.Data;
   {$IFDEF WINDOWS}
   //Расставляем цвета на свои места в Windows
   for x:=0 to 16383 do
    begin
     b:=TTData[n][x*4];
     TTData[n][x*4]:=TTData[n][x*4+2];
     TTData[n][x*4+2]:=b;
    end;
   {$ENDIF}
   //Подмешиваем альфу
   for x:=0 to 16383 do
    TTData[n][x*4+3]:=alp[x];
   glBindTexture(GL_TEXTURE_2D, TTID[n]);
   glTexImage2D(GL_TEXTURE_2D, 0, 4, 128, 128, 0, GL_RGBA, GL_UNSIGNED_BYTE, TTData[n]);
   glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
   glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
   glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
   glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
  end;
 FreeMem(alp);
 Editing:=False;
end;

procedure TMForm.PaintRecord(Logo, Track: integer; Z: GLDouble);
var
 dx,dy: GLDouble;
begin
 glEnable(GL_TEXTURE_2D);
 glBindTexture(GL_TEXTURE_2D, TTID[Logo]);
 dx:=cfg_tw*(Track-0.5);
 dy:=1+cfg_hh-cos((Z-1)/3);
 glBegin(GL_TRIANGLES);
  glTexCoord2f(1, 1);
  glVertex3d(RDbuf[0].x+dx,RDbuf[0].y+dy,RDbuf[0].z+Z);
  glTexCoord2f(1, 0);
  glVertex3d(RDbuf[1].x+dx,RDbuf[1].y+dy,RDbuf[1].z+Z);
  glTexCoord2f(0, 0);
  glVertex3d(RDbuf[2].x+dx,RDbuf[2].y+dy,RDbuf[2].z+Z);
  glVertex3d(RDbuf[3].x+dx,RDbuf[3].y+dy,RDbuf[3].z+Z);
  glTexCoord2f(1, 1);
  glVertex3d(RDbuf[4].x+dx,RDbuf[4].y+dy,RDbuf[4].z+Z);
  glTexCoord2f(0, 1);
  glVertex3d(RDbuf[5].x+dx,RDbuf[5].y+dy,RDbuf[5].z+Z);
 glEnd;
end;

procedure TMForm.tb_addrecClick(Sender: TObject);
begin
 FAddRec.Show;
end;

procedure TMForm.tb_editClick(Sender: TObject);
begin
 FEdit.Show;
end;

procedure TMForm.tb_newClick(Sender: TObject);
begin
 mf_newClick(Sender);
end;

procedure TMForm.tb_openClick(Sender: TObject);
begin
 mf_openClick(Sender);
end;

procedure TMForm.tb_reloadClick(Sender: TObject);
begin
 mf_reloadCLick(Sender);
end;

procedure TMForm.tb_saveasClick(Sender: TObject);
begin
 mf_saveasClick(Sender);
end;

procedure TMForm.tb_saveClick(Sender: TObject);
begin
 mf_saveClick(Sender);
end;

procedure TMForm.tb_setupClick(Sender: TObject);
begin
 FSetup.Show;
end;

procedure TMForm.tm_colorClick(Sender: TObject);
begin
 if (wp_track<0) then exit;
 FSetup.cd_t1.Color:=RGBtoColor(Tracks[wp_track].Color1*2,
  Tracks[wp_track].Color2*2, Tracks[wp_track].Color3*2);
 if not FSetup.cd_t1.Execute then exit;
 Tracks[wp_track].Color1:=Red(FSetup.cd_t1.Color) div 2;
 Tracks[wp_track].Color2:=Green(FSetup.cd_t1.Color) div 2;
 Tracks[wp_track].Color3:=Blue(FSetup.cd_t1.Color) div 2;
 Tracks[wp_track].Colored := True;
end;

procedure TMForm.tm_coloredClick(Sender: TObject);
begin
 if (wp_track<0) then exit;
 Tracks[wp_track].Colored:=not Tracks[wp_track].Colored;
 tm_colored.Checked:=Tracks[wp_track].Colored;
end;

procedure TMForm.tm_delClick(Sender: TObject);
var
 n,i: longint;
begin
 if (wp_track < 0) or (Tcount < 1) then exit;
 i:=0;
 for n:=0 to Rcount-1 do
  if (Records[n].Track = wp_track) then inc(i);
 if (i>0) then
  begin
   MessageDlg('Настройки дороги', 'Дорожка "' +
    Tracks[wp_track].Name + '" содержит '+inttostr(i) +
     ' записей и не может быть удалена.', mtInformation, [mbOk],0 );
   exit;
  end;
 if (MessageDlg('Удаление дорожки', 'Удалить дорожку "'+
  Tracks[wp_track].Name+'" ?', mtCustom, mbOkCancel, 0 ) = mrCancel)
   then exit;
 dec(Tcount);
 for n:=0 to Rcount-1 do
  if (Records[n].Track > wp_track) then dec(Records[n].Track);
 for n:=wp_track to (Tcount-1) do Tracks[n]:=Tracks[n+1];
 Editing:=False;
 SetupChanged:=True;
end;

procedure TMForm.tm_epopClick(Sender: TObject);
begin
 if (wp_track<0) then exit;
 if (Tracks[wp_track].Level < 1) then exit;
 Tracks[wp_track].Level:=Tracks[wp_track].Level-1;
end;

procedure TMForm.tm_epushClick(Sender: TObject);
begin
 if (wp_track < 0) then exit;
 if (Tracks[wp_track].Level > 8) then exit;
 Tracks[wp_track].Level:=Tracks[wp_track].Level+1;
end;

procedure TMForm.tm_renameClick(Sender: TObject);
var
 s: string;
 c: TColor;
begin
 if (wp_track<0) then exit;
 s:=InputBox('Редактор дороги','Название дорожки',Tracks[wp_track].Name);
 if (length(s)<1) then exit;
 Tracks[wp_track].Name:=s;
 if (wp_track mod 2 = 0) then
  c:=RGBtoColor(clr_h11*2,clr_h12*2,clr_h13*2) else
   c:=RGBtoColor(clr_h21*2,clr_h22*2,clr_h23*2);
 MakeTextTexture(s, True, 64, 128, c, WTData[wp_track]);
 glBindTexture(GL_TEXTURE_2D, WTID[wp_track]);
 glTexImage2D(GL_TEXTURE_2D, 0, 4, 64, 128, 0, GL_RGBA, GL_UNSIGNED_BYTE, WTData[wp_track]);
 OGLPaint(MForm);
end;

procedure TMForm.tm_rhintClick(Sender: TObject);
var
 s: string;
begin
 if (wp_track<0) then exit;
 s:=InputBox('Редактор дороги','Описание дорожки',Tracks[wp_track].Hint);
 if (length(s)<1) then exit;
 Tracks[wp_track].Hint:=s;
end;

procedure TMForm.TrackMenuPopup(Sender: TObject);
begin
 tm_colored.Checked:=Tracks[wp_track].Colored;
end;

procedure TMForm.WayMove;
var
 n: longint;
 b: boolean;
begin
 VTime2:=VTime1-cfg_wlt;
 ViewS:=0;
 ViewE:=Rcount-1;
 PanelTop1.Caption:='('+FSetup.way_length.Items[cfg_wl]+')   '+
  FormatDateTime('DD.MM.YYYY  hh:nn',VTime2);
 PanelBottom.Caption:=FormatDateTime('DD.MM.YYYY  hh:nn',VTime1);
 if (Rcount<1) then exit;
 b:=false;
 if (Records[Rcount-1].DTime < VTime2) then
  begin
   ViewE:=-1;
   exit;
  end;
 for n:=0 to Rcount-1 do
  begin
   if not b and (Records[n].DTime >= VTime2) then
    begin
     ViewS:=n;
     b:=true;
    end;
   if b and (Records[n].DTime > VTime1) then
    begin
     ViewE:=n-1;
     break;
    end;
  end;
end;

procedure TMForm.WayPoint; //(wp_index, wp_track, wp_record)
var
 s: double;
begin
 wp_track:=0;
 wp_record:=0;
 wp_index:=0;
 s:=MouseY / OGL.Height;
 if (s > 0.9782) then wp_index:=1 else //Временно
  if (Mpixel[2]=10) then wp_index:=2 else
   if (MPixel[2]=20) then wp_index:=3 else
    if (MPixel[2]=30) then wp_index:=4 else
     wp_index:=0;
 if (wp_index=2) or (wp_index=3) then
  wp_track:=Mpixel[0]*127 + Mpixel[1] else
   if (wp_index=4) then
    begin
     wp_record:=Mpixel[0]*127 + Mpixel[1];
     wp_track:=Records[wp_record].Track;
    end;
end;

procedure TMForm.FormCreate(Sender: TObject);
begin
 FSetup.InitCfg;
 PanelTop.Caption:='';
 PanelTop1.Caption:='';
 PanelBottom.Caption:='';
 OGL:=TOpenGLControl.Create(Self);
  with OGL do begin
   Name:='OGL';
   Left:=0;
   Top:=50;
   Width:=MForm.ClientWidth;
   Height:=MForm.ClientHeight-100;
   Parent:=Self;
   OnPaint:=@OGLPaint;
   OnResize:=@OGLResize;
   OnMouseDown:=@OGLMouseDown;
   OnMouseUp:=@OGLMouseUp;
   OnMouseMove:=@OGLMouseMove;
   OnMouseWheel:=@FormMouseWheel;
   {$IFDEF WINDOWS}
   MForm.OnKeyDown:=@FormKeyDown;
   {$ELSE}
   OnKeyDown:=@FormKeyDown;
   {$ENDIF}
   AutoResizeViewport:=true;
  end;
 XdY:=OGL.Width div OGL.Height;
 glClearColor (0, 0, 0, 0);
 glEnable(GL_TEXTURE_2D);
 glMatrixMode( GL_PROJECTION );
 glLoadIdentity();
 glOrtho( 0, 1, 0, 1, -1, 1);
 glMatrixMode( GL_MODELVIEW );
 glLoadIdentity();
 glOrtho( 0, 1, 0, 1, -1, 1);
 TImg.Canvas.Font.Size:=10;
 TImg.Canvas.Font.Color:=clWhite;
 MouseX:=0;
 MouseY:=0;
 GetMem(Mpixel,3);
 end;

procedure TMForm.FormDropFiles(Sender: TObject; const FileNames: array of String
  );
var
 n,t,c: integer;
 s: string;
begin
 c:=length(FileNames);
 if (c < 1) then exit;
 //Вброс файлов. Если попали не в заголовок дорожки,
 //то определяем её примерно
 WayPoint;
 if (wp_index = 2) then t:=wp_track else
  t:=(MouseX * TCount) div OGL.Width;
 if (t>TCount-1) then t:=TCount-1;
 if (t<0) then t:=0;
 //Как обычно проверим, не превышено ли максимальное количество записей
 if (Rcount >= MAX_RECORDS ) then
  begin
   MessageDlg('Ошибка',
    'Превышено максимальное количество записей!', mtError, [mbOk],0 );
   exit;
  end;
 //Создаём запись и копируем в неё документы
 RLtoRD[Rcount]:=Rcount;
 Records[Rcount].DTime:=-cfg_wlt*0.01+VTime1;
 Records[Rcount].Logo:=9;
 Records[Rcount].Track:=t;
 Records[Rcount].Data.Clear;
 if (c>1) then Records[Rcount].Name:='Перенесённые документы' else
  begin
   SplitString(FileNames[0],DIR_SPLITTER);
   Records[Rcount].Name:=SplitA[SplitN-1];
  end;
 for n:=0 to c-1 do
  begin
   if not fileexists(FileNames[n]) then begin dec(c); continue; end;
   s:=CopyDoc(FileNames[n]);
   if (pos('<link>/',s) = 1) then Records[Rcount].Data.Add(s)
    else dec(c);
  end;
 Records[Rcount].Data.Add(FormatDateTime('DD.MM.YYYY hh:nn',Now));
 Records[Rcount].Data.Add('Перенесено документов: '+inttostr(c));
 inc(Rcount);
 SortRecDocs(RCount-1);
 FEdit.SortDB;
 WayMove;
 OGLPaint(MForm);
end;

procedure TMForm.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState
  );
var
 ovx: single;
begin
 ovx:=ViewX;
 case Key of
  37: ViewX:=ViewX-0.02;
  39: ViewX:=ViewX+0.02;
  38: VTime1:=VTime1+(cfg_wlt/30);
  40: VTime1:=VTime1-(cfg_wlt/30);
 end;
 if (Tcount*cfg_tw > 0.6) then
  begin
   if (ViewX > 0.2) then ViewX:=0.2;
   if (ViewX < LimVX ) then ViewX:=LimVX;
  end else
   ViewX:=ovx;
 WayMove;
 OGLPaint(self);
 Moving:=False;
 OGLMouseMove(sender,[],MouseX,MouseY);
end;

procedure TMForm.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
 SaveConfig;
 SaveDB;
 Application.Terminate;
end;

procedure TMForm.FormMouseWheel(Sender: TObject; Shift: TShiftState;
  WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
begin
 if (WheelDelta<0) then VTime1:=VTime1-(cfg_wlt/15)
  else VTime1:=VTime1+(cfg_wlt/15);
 WayMove;
 OGLPaint(self);
end;

procedure TMForm.FormResize(Sender: TObject);
begin
 OGL.Width:=MForm.ClientWidth;
 OGL.Height:=MForm.ClientHeight-100;
 PanelBottom.Width:=MForm.ClientWidth;
 PanelTop.Width:=MForm.ClientWidth;
 PanelTop1.Width:=MForm.ClientWidth;
 PanelBottom.Top:=MForm.ClientHeight-50;
 XdY:=OGL.Width div OGL.Height;
 if (XdY<1) then MForm.Height:=MForm.Width;
end;

procedure TMForm.FormShow(Sender: TObject);
var
 n: integer;
 s: string;
begin
 s:='new';
 wlm1.Caption:=FSetup.way_length.Items[0];
 wlm2.Caption:=FSetup.way_length.Items[1];
 wlm3.Caption:=FSetup.way_length.Items[2];
 wlm4.Caption:=FSetup.way_length.Items[3];
 wlm5.Caption:=FSetup.way_length.Items[4];
 wlm6.Caption:=FSetup.way_length.Items[5];
 wlm7.Caption:=FSetup.way_length.Items[6];
 wlm8.Caption:=FSetup.way_length.Items[7];
 if (ParamCount > 0) then
  for n:=1 to ParamCount do
   if fileexists(ParamStr(n)) then
    begin
     s:=ParamStr(n);
     break;
    end;
 if (s <> 'new') then CheckAFD(SysToUTF8(s))
  else
   if fileexists(DB_DATAFILE) then LoadDB;
 SetWDbuf;
 SetRDBuf;
 MForm.Caption:=db_filename + ' - Дорога v. '+WDBVersion;
end;

procedure TMForm.me_editorClick(Sender: TObject);
begin
 FEdit.Show;
end;

procedure TMForm.me_setupClick(Sender: TObject);
begin
 FSetup.Show;
end;

procedure TMForm.mf_newClick(Sender: TObject);
begin
 if (MessageDlg('Создать новую дорогу',
  'Создать новую дорогу? Все несохранённые данные будут потеряны.',
   mtCustom, mbOkCancel, 0 ) = mrCancel) then exit;
 FSetup.InitCfg;
 SetupChanged:=true;
 OGLPaint(Sender);
end;

procedure TMForm.mf_openClick(Sender: TObject);
begin
 if OpenDialog1.Execute then CheckAFD(OpenDialog1.FileName);
end;

procedure TMForm.mf_reloadClick(Sender: TObject);
begin
 if (db_filename = DEFAULT_WAY_NAME) then
  begin
   MessageDlg('Ошибка',
    'Дорога ещё не сохранена!',mtError, [mbOk],0 );
   exit;
  end;
 if not fileexists(UTF8toSys(db_filename)) then
  begin
   MessageDlg('Ошибка',
    'Архив дороги не найден!',mtError, [mbOk],0 );
   exit;
  end;
 if (MessageDlg('Подтверждение',
      'Перезагрузить дорогу из сохранённого архива?',
      mtCustom, mbOkCancel, 0 ) = mrCancel) then exit;
 LoadAFD(db_filename);
end;

procedure TMForm.mf_saveasClick(Sender: TObject);
var
 fn: string;
begin
 SaveDialog1.Title:='Сохранение архива дороги';
 if not SaveDialog1.Execute then exit;
 fn:=SaveDialog1.FileName;
 SplitString(fn,'.');
 if (lowercase(SplitA[SplitN-1]) <> 'zfd') then fn:=fn+'.zfd';
 SaveZFD(fn);
end;

procedure TMForm.mf_saveClick(Sender: TObject);
begin
 if (db_filename = DEFAULT_WAY_NAME) then
  mf_saveas.Click else
   SaveZFD(db_filename);
end;

procedure TMForm.mh_aboutClick(Sender: TObject);
begin
 FLogo.Label2.Caption:=WDBAbout + {$I %DATE%} + ' FPC ' + {$I %FPCVERSION%};
 FLogo.Label3.Caption:=WDBAbout1;
 LogoLock:=False;
 FLogo.Show;
end;

procedure TMForm.mh_helpClick(Sender: TObject);
begin
 showmessage('Пока не реализовано.');
end;


procedure TMForm.OGLPaint(Sender: TObject);
var
 n: longint;
 cs,cn: longint;
 b: boolean;
 dx,dy,Z: GLDouble;
begin
 if Editing or FEdit.Visible or FSetup.Visible then exit;
 if SetupChanged then
  begin
   LogoLock:=True;
   FLogo.Show;
   Application.ProcessMessages;
   SetWDBuf;
   LogoLock:=False;
   Flogo.Hide;
   Application.ProcessMessages;
  end;
 glClear (GL_COLOR_BUFFER_BIT);
 //-------------Начало рисования буфера цвета------------
 glMatrixMode(GL_MODELVIEW);
 glPushMatrix;
 glLoadIdentity();
 glOrtho(0, 1, 0, 1, -1 ,1);
 glBegin(GL_TRIANGLES);
 glColor3b(0,0,0);
 glVertex3d(0,0,0);
 glVertex3d(0,1,0);
 glVertex3d(1,1,0);
 glVertex3d(1,1,0);
 glVertex3d(0,0,0);
 glVertex3d(1,0,0);
 glEnd;
 glPopMatrix;
 glMatrixMode (GL_PROJECTION);
 glPushMatrix;
 gluPerspective(80, XdY, 0, 20);
 glOrtho(0, 1, 0, 1, -1 ,4);
 glTranslatef(ViewX, 0.1, 0);
 for n:=0 to (Tcount-1) do
  begin
   glColor3b((n div 127),(n mod 127),10);
   cs:=n*Tsize;
   glBegin(GL_TRIANGLES);
   glVertex3d(WDbuf[cs].x,WDbuf[cs].y,WDbuf[cs].z);
   glVertex3d(WDbuf[cs+1].x,WDbuf[cs+1].y,WDbuf[cs+1].z);
   glVertex3d(WDbuf[cs+2].x,WDbuf[cs+2].y,WDbuf[cs+2].z);
   glVertex3d(WDbuf[cs+3].x,WDbuf[cs+3].y,WDbuf[cs+3].z);
   glVertex3d(WDbuf[cs+4].x,WDbuf[cs+4].y,WDbuf[cs+4].z);
   glVertex3d(WDbuf[cs+5].x,WDbuf[cs+5].y,WDbuf[cs+5].z);
   cs:=cs+6;
   glColor3b((n div 127),(n mod 127),20);
   for cn:=0 to (TRACK_SURFACE_COUNT*6-1) do
    glVertex3d(WDbuf[cn+cs].x,WDbuf[cn+cs].y,WDbuf[cn+cs].z);
   glEnd;
  end;
 for n:=ViewS to ViewE do
  begin
   //PaintRecord(cs,Records[n].Track+1,
   // ((VTime2-Records[n].DTime)/cfg_wlt*5.3 + 6.3));
   dx:=cfg_tw*(Records[n].Track+0.5);
   Z:=(VTime2-Records[n].DTime)/cfg_wlt*5.3 + 6.3;
   dy:=1+cfg_hh-cos((Z-1)/3);
   glColor3b((n div 127),(n mod 127),30);
   glBegin(GL_TRIANGLES);
    glVertex3d(RDbuf[0].x+dx,RDbuf[0].y+dy,RDbuf[0].z+Z);
    glVertex3d(RDbuf[1].x+dx,RDbuf[1].y+dy,RDbuf[1].z+Z);
    glVertex3d(RDbuf[2].x+dx,RDbuf[2].y+dy,RDbuf[2].z+Z);
    glVertex3d(RDbuf[3].x+dx,RDbuf[3].y+dy,RDbuf[3].z+Z);
    glVertex3d(RDbuf[4].x+dx,RDbuf[4].y+dy,RDbuf[4].z+Z);
    glVertex3d(RDbuf[5].x+dx,RDbuf[5].y+dy,RDbuf[5].z+Z);
   glEnd;
  end;
 glPopMatrix;
 glReadPixels(MouseX, OGL.Height-MouseY, 1, 1, GL_RGB, GL_BYTE, Mpixel);
 //OGL.SwapBuffers;
 //-------------Конец буфера цвета-------------------
 glClear (GL_COLOR_BUFFER_BIT);
 glMatrixMode(GL_MODELVIEW);
 glPushMatrix;
 glLoadIdentity();
 glOrtho(0, 1, 0, 1, -1 ,1);
 glBegin(GL_TRIANGLES);
 glColor3b(clr_b11,clr_b12,clr_b13);         // Рисование фона
 glVertex3d(0,0,0);
 glColor3b(clr_b21,clr_b22,clr_b23);
 glVertex3d(0,1,0);
 glVertex3d(1,1,0);
 glVertex3d(1,1,0);
 glColor3b(clr_b11,clr_b12,clr_b13);
 glVertex3d(0,0,0);
 glVertex3d(1,0,0);
 glEnd;
 glPopMatrix;                                // Рисование дороги
 glMatrixMode (GL_PROJECTION);
 glPushMatrix;
 gluPerspective(80, XdY, 0, 20);
 glOrtho(0, 1, 0, 1, -1 ,4);
 glTranslatef(ViewX, 0.1, 0);
 for n:=0 to (Tcount-1) do
  begin
   glColor3b(127,127,127);
   glEnable(GL_TEXTURE_2D);
   glBindTexture(GL_TEXTURE_2D, WTID[n]);
   cs:=n*Tsize;
   glBegin(GL_TRIANGLES);
   glTexCoord2f(0, 1);
   glVertex3d(WDbuf[cs].x,Tracks[n].Level/150 + WDbuf[cs].y,WDbuf[cs].z);
   glTexCoord2f(0, 0);
   glVertex3d(WDbuf[cs+1].x,WDbuf[cs+1].y,WDbuf[cs+1].z);
   glTexCoord2f(1, 0);
   glVertex3d(WDbuf[cs+2].x,WDbuf[cs+2].y,WDbuf[cs+2].z);
   glVertex3d(WDbuf[cs+3].x,WDbuf[cs+3].y,WDbuf[cs+3].z);
   glTexCoord2f(0, 1);
   glVertex3d(WDbuf[cs+4].x,Tracks[n].Level/150 + WDbuf[cs+4].y,WDbuf[cs+4].z);
   glTexCoord2f(1, 1);
   glVertex3d(WDbuf[cs+5].x,Tracks[n].Level/150 + WDbuf[cs+5].y,WDbuf[cs+5].z);
   glEnd;
   glDisable(GL_TEXTURE_2D);
   glBegin(GL_TRIANGLES);
   if (n mod 2 = 0) then b:=false else b:=true;
   cs:=cs+6;
   if Tracks[n].Colored then
    glColor3b(Tracks[n].Color1,Tracks[n].Color2,Tracks[n].Color3) else
     if b then glColor3b(clr_t21,clr_t22,clr_t23) else
      glColor3b(clr_t11,clr_t12,clr_t13);
   for cn:=0 to (TRACK_SURFACE_COUNT*6-1) do
    glVertex3d(WDbuf[cn+cs].x,WDbuf[cn+cs].y,WDbuf[cn+cs].z);
   glEnd;
  end;
 glColor3b(127,127,127);
 glEnable(GL_BLEND);
 glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
 for n:=ViewS to ViewE do
  begin
   cs:=Records[n].Logo+1;
   if (cs<0) or (cs > Fedit.LogosImages.Count-2) then cs:=0;
   PaintRecord(cs,Records[n].Track+1,
    ((VTime2-Records[n].DTime)/cfg_wlt*5.3 + 6.3));
  end;
 glDisable(GL_BLEND);
 glPopMatrix;
 OGL.SwapBuffers;
end;

procedure TMForm.OGLResize(Sender: TObject);
begin
  if OGL.Height <= 0 then exit;
end;

procedure TMForm.OGLMouseDown(Sender: TObject; Button: TMouseButton; State: TShiftState; X, Y: LongInt);
begin
 Moving:=true;
 PntX:=X;
 OVX:=ViewX;
end;

procedure TMForm.OGLMouseUp(Sender: TObject; Button: TMouseButton; State: TShiftState; X, Y: LongInt);
begin
 Moving:=false;
 if (Button = mbRight) then
  begin
   if (wp_index = 2) then TrackMenu.PopUp;
   if (wp_index = 4) then RecMenu.PopUp;
   exit;
  end;
 if (wp_index = 4) then FRecView.ShowRecord(wp_record);
end;

procedure TMForm.OGLMouseMove(Sender: TObject; State: TShiftState; X, Y: LongInt);
begin
 if Moving then
  if (Tcount*cfg_tw > 0.6) then
   begin
    ViewX:=(X-PntX)/720+OVX;
    if (ViewX > 0.2) then ViewX:=0.2;
    if (ViewX < LimVX ) then ViewX:=LimVX;
    WayMove;
   end;
 MouseX:=X;
 MouseY:=Y;
 if (MPixel[2]>25) then OGL.Cursor:=crHandPoint else OGL.Cursor:=crDefault;
 WayPoint;
 if (wp_index = 2) then PanelTop.Caption:=Tracks[wp_track].Hint else
  if (wp_index = 4) then
   PanelTop.Caption:=
    FormatDateTime('DD.MM.YYYY - ',Records[wp_record].DTime)
     +Records[wp_record].Name else
      PanelTop.Caption:='';
 OGLPaint(self);
end;

end.

