unit procs;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils;

var
 SplitA: array [0..255] of string;
 SplitN: integer;

//Преобразование строк в числа с коррекцией ошибок
function toInt(s: string): integer;
function toDouble(s: string): double;
//Чтение параметра из файла настройки
function getpar(nfile,npar:string):string;
//Делитель строк (результат в SplitA и SplitN)
procedure SplitString(S: String; Splitter: Char);
//Чтение даты и времени
function WDBReadDateTime(s: string): TDateTime;
//Запись даты и времени
function WDBWriteDateTime(d: TDateTime): String;

implementation

function pow10(r: integer): int64;
var
 n: integer;
 rz: int64;
begin
 rz:=1;
 if (r>0) then
  for n:=1 to r do
   rz:=rz*10;
 pow10:=rz;
end;

function toInt(s: string): integer;
var
 n,r,rz: integer;
 sz: boolean;
begin
 r:=0;
 rz:=0;
 sz:=false;
 for n:=length(s) downto 1  do
  begin
   if (s[n]='-') then sz:= true;
   if (ord(s[n])>47) and (ord(s[n])<58) then
    begin
     r:=r+(ord(s[n])-48)*pow10(rz);
     inc(rz);
    end;
  end;
 if sz then r:=-r;
 toInt:=r;
end;

function toDouble(s: string): double;
var
 n,rz: integer;
 sz: boolean;
 r: double;
begin
 r:=0;
 rz:=0;
 sz:=false;
 for n:=length(s) downto 1  do
  begin
   if (s[n]='-') then sz:= true;
   if (ord(s[n])>47) and (ord(s[n])<58) then
    begin
     r:=r+(ord(s[n])-48)*pow10(rz);
     inc(rz);
    end;
   if (s[n]=',') or (s[n]='.') then
    begin
     r:=r / pow10(rz);
     rz:=0;
    end;
  end;
 if sz then r:=-r;
 toDouble:=r;
end;

function getpar(nfile,npar:string):string;
var
 gpf:textfile;
 n:smallint;
 gps,gpt,tmp:string;
begin
 gps:='';
 if not fileexists(nfile) then exit;
 assignfile(gpf,nfile);
 reset(gpf);
 gps:='';
 while not eof(gpf) do
  begin
   readln(gpf,gpt);
   if (length(gpt)+2<length(npar)) or (gpt='') then continue;
   tmp:='';
   for n:=1 to length(npar) do tmp:=tmp+gpt[n];
   if (gpt[length(npar)+1]='=') then if lowerCase(tmp)=lowerCase(npar) then
    begin
     for n:=length(npar)+2 to length(gpt) do gps:=gps+gpt[n];
     break;
    end;
  end;
 closefile(gpf);
 getpar:=gps;
end;

procedure SplitString(S: String; Splitter: Char);
var
 n: integer;
begin
 for n:=0 to 255 do SplitA[n]:='';
 if length(S) < 1 then
  begin
   SplitN:=0;
   exit;
  end;
 SplitN:=1;
 for n:=1 to length(S) do
  if (S[n]=Splitter) then
   begin
    inc(SplitN);
    if (SplitN > 256) then exit;
   end else
    SplitA[SplitN-1]:=SplitA[SplitN-1]+S[n];
end;

function WDBReadDateTime(s: string): TDateTime;
var
 r: double;
 d,m,y: word;
begin
 r:=0;
 if (length(s) = 12) then
  begin
   d := toint(copy(s,1,2));
   m := toint(copy(s,3,2));
   y := toint(copy(s,5,4));
   if (d>31) then d:=31;
   if (m>12) then m:=12;
   if (y>9999) then y:=1900;
   r:=EncodeDate(y,m,d);
   d := toint(copy(s,9,2));
   m := toint(copy(s,11,2));
   if (d>23) then d:=23;
   if (m>59) then m:=59;
   r:=r+EncodeTime(d,m,0,0);
  end;
 Result := r;
end;

function WDBWriteDateTime(d: TDateTime): String;
begin
 Result := FormatDateTime('DDMMYYYYhhnn',d);
end;

end.

