unit recviewform;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  ExtCtrls, Process, LCLIntf, wdb_vars;

type

  { TFRecView }

  TFRecView = class(TForm)
    LabelTrack: TLabel;
    LabelDate: TLabel;
    LabelHeader: TLabel;
    DocList: TListBox;
    LogoImage: TImage;
    Memo1: TMemo;
    procedure DocListDblClick(Sender: TObject);
    procedure DocListKeyPress(Sender: TObject; var Key: char);
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure ShowRecord(Rec: longint);
    procedure RunDoc(FileName: String);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  FRecView: TFRecView;
  FVRec: longint;
  Docs: TStringList;
  dp: TProcess;

implementation

uses editform, procs;

{$R *.lfm}

{ TFRecView }

procedure TFRecView.FormCreate(Sender: TObject);
begin
 FRecView.Caption:='Просмотр записи';
 FVRec:=-1;
 Docs := TStringList.Create;
end;

procedure TFRecView.DocListKeyPress(Sender: TObject; var Key: char);
begin
 if (Key <> chr(13) {Enter}) then exit;
 if (DocList.ItemIndex < 0) then exit;
 RunDoc(Docs.Strings[DocList.ItemIndex]);
end;

procedure TFRecView.DocListDblClick(Sender: TObject);
begin
 if (DocList.ItemIndex < 0) then exit;
 RunDoc(Docs.Strings[DocList.ItemIndex]);
end;

procedure TFRecView.FormResize(Sender: TObject);
begin
 Memo1.Height:=FRecView.ClientHeight - 160;
 DocList.Width:=FRecView.ClientWidth - 112;
end;

procedure TFRecView.ShowRecord(Rec: longint);
var
 n: integer;
begin
 if (Rec < 0) or (Rec >= Rcount) then FRecView.Hide
  else FVRec:=Rec;
 LabelHeader.Caption:=Records[FVRec].Name;
 LabelDate.Caption:='Дата: '+FormatDateTime('DD.MM.YYYY hh:mm',Records[FVRec].DTime);
 LabelTrack.Caption:='Дорожка: '+Tracks[Records[FVRec].Track].Name;
 FEdit.LogosImages.GetBitmap(Records[FVRec].Logo+2,LogoImage.Picture.Bitmap);
 Memo1.Clear;
 DocList.Clear;
 Docs.Clear;
 //Memo1.Lines := Records[FVrec].Data;
 for n:=0 to Records[FVRec].Data.Count-1 do
  begin
   if (pos('<link>/',Records[FVRec].Data.Strings[n]) <> 1)
    then Memo1.Lines.Add(Records[FVRec].Data.Strings[n]) else
     begin
      SplitString(Records[FVRec].Data.Strings[n],'/');
      if (SplitN = 3) then
       begin
        DocList.Items.Add(SplitA[1]);
        Docs.Add(SplitA[2]);
       end else Memo1.Lines.Add(Records[FVRec].Data.Strings[n])
     end;
  end;
 FRecView.Show;
end;

procedure TFRecView.RunDoc(FileName: string);
var
 dn,de: string;
 n: integer;
 ee: boolean;
begin
 dn:=DB_FILESDIR+DIR_SPLITTER+FileName;
 if not fileexists(dn) then
  begin
   MessageDlg('Ошибка доступа к документу',
    'Документ "'+dn+'" не найден!',mtError, [mbOk],0 );
   exit;
  end;
 ee:=false;
 //Получаем расширение документа
 SplitString(dn,'.');
 de:='';
 if (SplitN>1) then de:=SplitA[SplitN-1];
 if (length(de) > 10) then de:='';
 //Ишем внутреннюю ассоциацию, если нашли - запускаем программу
 for n:=0 to (Doc_count-1) do
  if (Doc_ext[n] = de) then
   begin
    dp:=TProcess.Create(nil);
    dp.CommandLine:=Doc_cmd[n]+' "'+WSDirName+DIR_SPLITTER+dn+'"';
    dp.Execute;
    exit;
   end;
 //Иначе - открываем документ в системной программе
 OpenDocument(WSDirName+DIR_SPLITTER+dn);
end;

end.

