unit setupform;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  ExtCtrls, GL, procs, wdb_vars;

type

  { TFSetup }

  TFSetup = class(TForm)
    Button1: TButton;
    b_del: TButton;
    b_add: TButton;
    b_prog: TButton;
    cl_t: TPanel;
    DocCmdEdit: TEdit;
    DocExtEdit: TEdit;
    t_level: TEdit;
    GroupBox3: TGroupBox;
    ExtList: TListBox;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    OpenDialog1: TOpenDialog;
    t_clr: TCheckBox;
    t_hint: TEdit;
    Label9: TLabel;
    l_tcount: TLabel;
    t_name: TEdit;
    Label8: TLabel;
    t_add: TButton;
    t_del: TButton;
    t_up: TButton;
    t_down: TButton;
    cd_t1: TColorDialog;
    GroupBox2: TGroupBox;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    cl_t1: TPanel;
    cl_h1: TPanel;
    cl_b1: TPanel;
    cl_t2: TPanel;
    cl_h2: TPanel;
    cl_b2: TPanel;
    Label7: TLabel;
    track_list: TListBox;
    way_length: TComboBox;
    header_height: TComboBox;
    Label3: TLabel;
    track_width: TComboBox;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure b_addClick(Sender: TObject);
    procedure b_delClick(Sender: TObject);
    procedure b_progClick(Sender: TObject);
    procedure cl_b1Click(Sender: TObject);
    procedure cl_b2Click(Sender: TObject);
    procedure cl_h1Click(Sender: TObject);
    procedure cl_h2Click(Sender: TObject);
    procedure cl_t1Click(Sender: TObject);
    procedure cl_t2Click(Sender: TObject);
    procedure cl_tClick(Sender: TObject);
    procedure ExtListMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ExtListSelectionChange(Sender: TObject; User: boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure header_heightChange(Sender: TObject);
    procedure InitCfg;
    procedure FillForm;
    procedure FormDeactivate(Sender: TObject);
    procedure track_listSelectionChange(Sender: TObject; User: boolean);
    procedure track_widthChange(Sender: TObject);
    procedure t_addClick(Sender: TObject);
    procedure t_clrChange(Sender: TObject);
    procedure t_delClick(Sender: TObject);
    procedure t_downClick(Sender: TObject);
    procedure t_hintChange(Sender: TObject);
    procedure t_levelChange(Sender: TObject);
    procedure t_nameChange(Sender: TObject);
    procedure t_upClick(Sender: TObject);
    procedure way_lengthChange(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

procedure SetWLT;

var
  FSetup: TFSetup;

implementation

 uses editform;

{$R *.lfm}

procedure SetWLT;
begin
 case cfg_wl of
  0: cfg_wlt:=1;
  1: cfg_wlt:=3;
  2: cfg_wlt:=7;
  3: cfg_wlt:=30;
  4: cfg_wlt:=90;
  5: cfg_wlt:=182.625;
  6: cfg_wlt:=365.25;
  7: cfg_wlt:=1095.75;
 end;
end;

{ TFSetup }

procedure TFSetup.FormDeactivate(Sender: TObject);
begin
 FSetup.Hide;
end;

procedure TFSetup.track_listSelectionChange(Sender: TObject; User: boolean);
begin
 if (track_list.ItemIndex < 0) then
  begin
   cl_t.Color:=clDefault;
   l_tcount.Caption:=inttostr(Tcount);
   exit;
  end;
 Editing:=True;
 t_name.Text:=Tracks[track_list.ItemIndex].Name;
 t_hint.Text:=Tracks[track_list.ItemIndex].Hint;
 t_level.Text:=inttostr(Tracks[track_list.ItemIndex].Level);
 t_clr.Checked:=Tracks[track_list.ItemIndex].Colored;
 cl_t.Color:=RGBtoColor
  ( Tracks[track_list.ItemIndex].Color1 * 2,
   Tracks[track_list.ItemIndex].Color2 * 2,
    Tracks[track_list.ItemIndex].Color3 * 2 );
 l_tcount.Caption:=inttostr(track_list.ItemIndex+1)+' / '+inttostr(Tcount);
 Editing:=False;
end;

procedure TFSetup.track_widthChange(Sender: TObject);
begin
 cfg_tw:=toInt(track_width.Caption) / 100;
 if (cfg_tw < 0.01) then cfg_tw:=0.01;
 if (cfg_tw > 0.3) then cfg_tw:=0.3;
end;

procedure TFSetup.t_addClick(Sender: TObject);
begin
 if (Tcount>=MAX_TRACKS) then
  begin
   MessageDlg('Настройки дороги',
    'Достигнуто максимальное количество дорожек!',mtError, [mbOk],0 );
   exit;
  end;
 inc(Tcount);
 Tracks[Tcount-1].Colored:=False;
 Tracks[Tcount-1].Level:=0;
 Tracks[Tcount-1].Name:='Дорожка';
 Tracks[Tcount-1].Hint:='Новая дорожка';
 track_list.Items.Add(Tracks[Tcount-1].Name);
 track_list.ItemIndex:=Tcount-1;
 t_name.SetFocus;
 t_name.SelectAll;
end;

procedure TFSetup.t_clrChange(Sender: TObject);
begin
 if (track_list.ItemIndex<0) or Editing then exit;
 Tracks[track_list.ItemIndex].Colored:=t_clr.Checked;
end;

procedure TFSetup.t_delClick(Sender: TObject);
var n,i: longint;
begin
 if (track_list.ItemIndex<0) or (Tcount<1) then exit;
 i:=0;
 for n:=0 to Rcount-1 do
  if (Records[n].Track = track_list.ItemIndex) then inc(i);
 if (i>0) then
  begin
   MessageDlg('Настройки дороги', 'Дорожка "' +
    Tracks[track_list.ItemIndex].Name + '" содержит '+inttostr(i) +
     ' записей и не может быть удалена.', mtInformation, [mbOk],0 );
   exit;
  end;
 dec(Tcount);
 for n:=0 to Rcount-1 do
  if (Records[n].Track > track_list.ItemIndex) then dec(Records[n].Track);
 for n:=track_list.ItemIndex to (Tcount-1) do Tracks[n]:=Tracks[n+1];
 track_list.Items.Delete(track_list.ItemIndex);
 l_tcount.Caption:=inttostr(Tcount);
end;

procedure TFSetup.t_downClick(Sender: TObject);
var
 n: longint;
 t: WDBtrack;
begin
 if (track_list.ItemIndex < 0) or (Tcount < 2) then exit;
 if (track_list.ItemIndex > Tcount-2) then exit;
 Editing:=True;
 t:=Tracks[track_list.ItemIndex];
 Tracks[track_list.ItemIndex]:=Tracks[track_list.ItemIndex+1];
 Tracks[track_list.ItemIndex+1]:=t;
 track_list.Items.Strings[track_list.ItemIndex+1]:=Tracks[track_list.ItemIndex+1].Name;
 track_list.Items.Strings[track_list.ItemIndex]:=Tracks[track_list.ItemIndex].Name;
 for n:=0 to (Rcount-1) do
  if (Records[n].Track = track_list.ItemIndex) then inc(Records[n].Track) else
   if (Records[n].Track = track_list.ItemIndex+1) then dec(Records[n].Track);
 track_list.ItemIndex:=track_list.ItemIndex + 1;
 Editing:=false;
end;

procedure TFSetup.t_hintChange(Sender: TObject);
begin
 if (track_list.ItemIndex<0) or (length(t_hint.Text)<1) or Editing then exit;
 Tracks[track_list.ItemIndex].Hint:=t_hint.Text;
end;

procedure TFSetup.t_levelChange(Sender: TObject);
var
 n:integer;
begin
 if (track_list.ItemIndex<0) or Editing then exit;
 n:=toint(t_level.Text);
 if (n<0) or (n>9) then n:=0;
 Tracks[track_list.ItemIndex].Level:=n;
end;

procedure TFSetup.t_nameChange(Sender: TObject);
var
 s: string;
begin
 if (track_list.ItemIndex<0) or (length(t_name.Text)<1) or Editing then exit;
 if (Tracks[track_list.ItemIndex].Level > 0) then s:='> ' else s:='';
 Tracks[track_list.ItemIndex].Name:=t_name.Text;
 track_list.Items[track_list.ItemIndex]:=s+Tracks[track_list.ItemIndex].Name;
end;

procedure TFSetup.t_upClick(Sender: TObject);
var
 n: longint;
 t: WDBtrack;
begin
 if (track_list.ItemIndex<1) or (Tcount<2) then exit;
 Editing:=True;
 t:=Tracks[track_list.ItemIndex];
 Tracks[track_list.ItemIndex]:=Tracks[track_list.ItemIndex-1];
 Tracks[track_list.ItemIndex-1]:=t;
 track_list.Items.Strings[track_list.ItemIndex-1]:=Tracks[track_list.ItemIndex-1].Name;
 track_list.Items.Strings[track_list.ItemIndex]:=Tracks[track_list.ItemIndex].Name;
 for n:=0 to (Rcount-1) do
  if (Records[n].Track = track_list.ItemIndex) then dec(Records[n].Track) else
   if (Records[n].Track = track_list.ItemIndex-1) then inc(Records[n].Track);
 track_list.ItemIndex:=track_list.ItemIndex - 1;
 Editing:=false;
end;

procedure TFSetup.way_lengthChange(Sender: TObject);
begin
 cfg_wl:=way_length.ItemIndex;
 SetWLT;
end;

procedure TFSetup.InitCfg;
var n: integer;
begin
 Tcount:=10;
 Rcount:=0;
 db_filename:=DEFAULT_WAY_NAME;
 for n:=0 to MAX_TRACKS do
 begin
  Tracks[n].Name:='Дорожка '+inttostr(n+1);
  Tracks[n].Hint:=Tracks[n].Name;
  Tracks[n].Level:=0;
  Tracks[n].Colored:=False;
  Tracks[n].Color1:=0;
  Tracks[n].Color2:=64;
  Tracks[n].Color3:=127;
 end;
 cfg_tw:=0.12;
 cfg_hh:=0.24;
 cfg_wl:=3;
 cfg_wlt:=30;
 clr_b11:=0;
 clr_b12:=0;
 clr_b13:=0;
 clr_b21:=0;
 clr_b22:=0;
 clr_b23:=50;
 clr_t11:=0;
 clr_t12:=64;
 clr_t13:=127;
 clr_t21:=0;
 clr_t22:=45;
 clr_t23:=90;
 clr_h11:=0;
 clr_h12:=50;
 clr_h13:=127;
 clr_h21:=0;
 clr_h22:=15;
 clr_h23:=110;
end;

procedure TFSetup.FormShow(Sender: TObject);
begin
 FillForm;
end;

procedure TFSetup.header_heightChange(Sender: TObject);
begin
 cfg_hh:=toInt(header_height.Caption) / 100;
 if (cfg_hh < 0.05) then cfg_hh:=0.05;
 if (cfg_hh > 0.5) then cfg_hh:=0.5;
end;

procedure TFSetup.FormCreate(Sender: TObject);
begin
 Editing:=True;
 FSetup.Caption:='Настройки базы данных';
 t_add.Caption:='Добавить';
 t_del.Caption:='Удалить';
 t_up.Caption:='Вверх';
 t_down.Caption:='Вниз';
 t_name.Text:='';
 t_hint.Text:='';
 t_level.Text:='0';
 t_clr.Caption:='Цвет дорожки';
 cl_t.Caption:='';
 cl_t1.Caption:='';
 cl_t2.Caption:='';
 cl_h1.Caption:='';
 cl_h2.Caption:='';
 cl_b1.Caption:='';
 cl_b2.Caption:='';
 track_width.Items.Clear;
 track_width.Items.Add('5');
 track_width.Items.Add('10');
 track_width.Items.Add('15');
 track_width.Items.Add('20');
 track_width.Items.Add('25');
 header_height.Items.Clear;
 header_height.Items.Add('10');
 header_height.Items.Add('15');
 header_height.Items.Add('20');
 header_height.Items.Add('30');
 header_height.Items.Add('40');
 way_length.Items.Clear;
 way_length.Items.Add('День');
 way_length.Items.Add('3 дня');
 way_length.Items.Add('Неделя');
 way_length.Items.Add('Месяц');
 way_length.Items.Add('3 месяца');
 way_length.Items.Add('6 месяцев');
 way_length.Items.Add('Год');
 way_length.Items.Add('3 года');
 Editing:=False;
 DocCmdEdit.Text:='';
 DocExtEdit.Text:='';
 b_prog.Caption:='Выбрать';
 b_add.Caption:='Добавить';
 b_del.Caption:='Удалить';
 Doc_count:=0;
end;

procedure TFSetup.FormHide(Sender: TObject);
begin
 Editing:=False;
 SetupChanged:=True;
end;

procedure TFSetup.cl_t1Click(Sender: TObject);
begin
 cd_t1.Color:=cl_t1.Color;
 if not cd_t1.Execute then exit;
 cl_t1.Color:=cd_t1.Color;
 clr_t11:=Red(cl_t1.Color) div 2;
 clr_t12:=Green(cl_t1.Color) div 2;
 clr_t13:=Blue(cl_t1.Color) div 2;
end;

procedure TFSetup.cl_h1Click(Sender: TObject);
begin
 cd_t1.Color:=cl_h1.Color;
 if not cd_t1.Execute then exit;
 cl_h1.Color:=cd_t1.Color;
 clr_h11:=Red(cl_h1.Color) div 2;
 clr_h12:=Green(cl_h1.Color) div 2;
 clr_h13:=Blue(cl_h1.Color) div 2;
end;

procedure TFSetup.cl_b1Click(Sender: TObject);
begin
 cd_t1.Color:=cl_b1.Color;
 if not cd_t1.Execute then exit;
 cl_b1.Color:=cd_t1.Color;
 clr_b11:=Red(cl_b1.Color) div 2;
 clr_b12:=Green(cl_b1.Color) div 2;
 clr_b13:=Blue(cl_b1.Color) div 2;
end;

procedure TFSetup.Button1Click(Sender: TObject);
begin
 FSetup.Hide;
end;

procedure TFSetup.b_addClick(Sender: TObject);
begin
 if (ExtList.ItemIndex < 0) then
  begin
   if (Doc_count >= MAX_DOC_EXT) then exit;
   Doc_ext[Doc_count]:=lowercase(DocExtEdit.Text);
   Doc_cmd[Doc_count]:=DocCmdEdit.Text;
   ExtList.Items.Add(Doc_ext[Doc_count]);
   ExtList.ItemIndex:=Doc_count;
   inc(Doc_count);
  end else
   begin
    ExtList.Items.Strings[ExtList.ItemIndex]:=DocExtEdit.Text;
    Doc_ext[ExtList.ItemIndex]:=lowercase(DocExtEdit.Text);
    Doc_cmd[ExtList.ItemIndex]:=DocCmdEdit.Text;
   end;
end;

procedure TFSetup.b_delClick(Sender: TObject);
var
 n: integer;
begin
 if (ExtList.ItemIndex < 0) then exit;
 for n:=ExtList.ItemIndex to (Doc_count-1) do
  begin
   Doc_ext[n]:=Doc_ext[n+1];
   Doc_cmd[n]:=Doc_cmd[n+1];
  end;
 ExtList.Items.Delete(ExtList.ItemIndex);
 dec(Doc_count);
 ExtList.ItemIndex:=-1;
end;

procedure TFSetup.b_progClick(Sender: TObject);
begin
 OpenDialog1.Filter:='*.*';
 OpenDialog1.Title:='Указать программу для открытия документов типа "'
  +DocExtEdit.Text+'"';
 if not OpenDialog1.Execute then exit;
 DocCmdEdit.Text:='"'+OpenDialog1.FileName+'"';
end;

procedure TFSetup.cl_b2Click(Sender: TObject);
begin
 cd_t1.Color:=cl_b2.Color;
 if not cd_t1.Execute then exit;
 cl_b2.Color:=cd_t1.Color;
 clr_b21:=Red(cl_b2.Color) div 2;
 clr_b22:=Green(cl_b2.Color) div 2;
 clr_b23:=Blue(cl_b2.Color) div 2;
end;

procedure TFSetup.cl_h2Click(Sender: TObject);
begin
 cd_t1.Color:=cl_h2.Color;
 if not cd_t1.Execute then exit;
 cl_h2.Color:=cd_t1.Color;
 clr_h21:=Red(cl_h2.Color) div 2;
 clr_h22:=Green(cl_h2.Color) div 2;
 clr_h23:=Blue(cl_h2.Color) div 2;
end;

procedure TFSetup.cl_t2Click(Sender: TObject);
begin
 cd_t1.Color:=cl_t2.Color;
 if not cd_t1.Execute then exit;
 cl_t2.Color:=cd_t1.Color;
 clr_t21:=Red(cl_t2.Color) div 2;
 clr_t22:=Green(cl_t2.Color) div 2;
 clr_t23:=Blue(cl_t2.Color) div 2;
end;

procedure TFSetup.cl_tClick(Sender: TObject);
begin
 if (track_list.ItemIndex<0) then exit;
 cd_t1.Color:=cl_t.Color;
 if not cd_t1.Execute then exit;
 cl_t.Color:=cd_t1.Color;
 Tracks[track_list.ItemIndex].Color1:=Red(cl_t.Color) div 2;
 Tracks[track_list.ItemIndex].Color2:=Green(cl_t.Color) div 2;
 Tracks[track_list.ItemIndex].Color3:=Blue(cl_t.Color) div 2;
end;

procedure TFSetup.ExtListMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 if (Button = mbRight) then ExtList.ItemIndex:=-1;
end;

procedure TFSetup.ExtListSelectionChange(Sender: TObject; User: boolean);
begin
 if (ExtList.ItemIndex<0) then
   begin
    b_add.Caption:='Добавить';
    b_del.Enabled:=false;
   end else
    begin
     b_add.Caption:='Сохранить';
     b_del.Enabled:=True;
     DocExtEdit.Text:=Doc_ext[ExtList.ItemIndex];
     DocCmdEdit.Text:=Doc_cmd[ExtList.ItemIndex];
    end;
end;

procedure TFSetup.FillForm;
var
 n: integer;
begin
 cl_t1.Color:=RGBtoColor(clr_t11*2,clr_t12*2,clr_t13*2);
 cl_t2.Color:=RGBtoColor(clr_t21*2,clr_t22*2,clr_t23*2);
 cl_h1.Color:=RGBtoColor(clr_h11*2,clr_h12*2,clr_h13*2);
 cl_h2.Color:=RGBtoColor(clr_h21*2,clr_h22*2,clr_h23*2);
 cl_b1.Color:=RGBtoColor(clr_b11*2,clr_b12*2,clr_b13*2);
 cl_b2.Color:=RGBtoColor(clr_b21*2,clr_b22*2,clr_b23*2);
 track_width.Caption:=inttostr(round(cfg_tw*100));
 header_height.Caption:=inttostr(round(cfg_hh*100));
 way_length.ItemIndex:=cfg_wl;
 track_list.Items.Clear;
 Tracks[0].Level:=0;
 for n:=0 to (Tcount-1) do
  if (Tracks[n].Level = 0) then track_list.Items.Add(Tracks[n].Name) else
   track_list.Items.Add('> '+Tracks[n].Name);
 l_tcount.Caption:=inttostr(TCount);
 ExtList.Items.Clear;
 for n:=0 to Doc_count-1 do ExtList.Items.Add(Doc_ext[n]);
 DocCmdEdit.Text:='';
 DocExtEdit.Text:='';
 ExtList.ItemIndex:=-1;
end;

end.

