unit wdb_vars;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, GL, procs;

const
  WDBVersion = '0.1.0 alpha';
  WDBAbout = 'Сборка:';
  WDBAbout1 = 'Автор: Шимигон Алексей | vk.com/ashimigon';
  WDBVersionNumber = 4;
  CFG_FILE = 'waydb.conf';
  DB_DATAFILE = 'waydata.fd2';
  DB_WAYFILE = 'way.conf';
  DB_FILESDIR = 'files';
  {$IFDEF WINDOWS}
  WORK_DIR = 'WORKSPACE';
  DIR_SPLITTER = '\';
  {$ELSE}
  WORK_DIR = 'WORKSPACE';
  DIR_SPLITTER = '/';
  {$ENDIF}
  MAX_TRACKS = 512;
  MAX_DOC_EXT = 999;
  DEFAULT_WAY_NAME = 'Дорога';
  MAX_RECORDS = 15000;

type
  WDBtrack = record
   Name: string;
   Hint: string;
   Level: byte;
   Colored: boolean;
   Color1, Color2, Color3: GLByte;
  end;

  WDBvertex = record
   x,y,z: GLdouble;
  end;

  WDBrecord = record
   Name: string;
   Logo, Track: word;
   Data: TStringList;
   DTime: TDateTime;
  end;


var
  Editing: boolean;
  cfg_tw, cfg_hh: single;
  cfg_wl: byte;
  cfg_wlt: TDateTime;
  clr_t11, clr_t12, clr_t13, clr_t21, clr_t22, clr_t23: GLbyte;
  clr_b11, clr_b12, clr_b13, clr_b21, clr_b22, clr_b23: GLbyte;
  clr_h11, clr_h12, clr_h13, clr_h21, clr_h22, clr_h23: GLbyte;
  db_filename: string;
  Tracks: array [0..MAX_TRACKS] of WDBTrack;
  Tcount: integer;
  SetupChanged: boolean;
  Doc_ext: array [0..MAX_DOC_EXT] of string;
  Doc_cmd: array [0..MAX_DOC_EXT] of string;
  Doc_Count: integer;
  WSDirName: string;
  Records: array [0..MAX_RECORDS] of WDBrecord;
  RCount, LIndex: longint;

  //Вид OpenGL
  WDbuf: array of WDBvertex;
  RDbuf: array [0..5] of WDBvertex;
  WDBS, Tsize: longint;
  ViewX, OVX, LimVX, XdY: single;
  Moving: boolean;
  PntX, MouseX, MouseY: integer;
  VTime1, VTime2: TDateTime;
  ViewS, ViewE: longint;
  Mpixel: pbyte;

  //Текстуры
  WTID: array [0..MAX_TRACKS] of GLuint;
  WTData: array [0..MAX_TRACKS] of ^Byte;
  TTID: array of GLuint;
  TTData: array of ^Byte;

  //Выходные переменные для процедуры WayPoint
  wp_index, wp_track: integer;
  wp_record: longint;

procedure SortRecDocs(NRec: longint);

implementation

procedure SortRecDocs(NRec: longint);
var
 n: longint;
 b,l1,l2: boolean;
 s: string;
begin
 if (NRec < 0) or (NRec > RCount-1) or
  (Records[NRec].Data.Count < 2) then exit;
 b:=true;
 while b do
  begin
   b:=false;
   for n:=0 to (Records[NRec].Data.Count-2) do
    begin
     if (pos('<link>/',Records[NRec].Data.Strings[n]) = 1) then l1:=True
      else l1:=False;
     if (pos('<link>/',Records[NRec].Data.Strings[n+1]) = 1) then l2:=True
      else l2:=False;
     if l2 and not l1 then
      begin
       Records[NRec].Data.Exchange(n,n+1);
       b:=true;
      end;
     if l1 and l2 then
      begin
       SplitString(Records[NRec].Data.Strings[n],'/');
       if (SplitN<>3) then continue;
       s:=SplitA[1];
       SplitString(Records[NRec].Data.Strings[n+1],'/');
       if (SplitN<>3) then continue;
       if (s > SplitA[1]) then
        begin
         Records[NRec].Data.Exchange(n,n+1);
         b:=true;
        end;
      end;
    end;
  end;
end;

end.

